import { r as o } from "../../../react.esm-GKFzux-6.mjs";
import a from "../useOverlayManagerEvents.js";
import p from "../../timer/TimedEventManager.js";
import { useOverlayManagerContext as O } from "../../context/OverlayManagerContext.js";
import { e as y } from "../../../events-B7I8KoZ9.mjs";
jest.mock("../../context/OverlayManagerContext");
describe("useOverlayManagerEvents", () => {
  let e, u, r, m;
  const n = new y.EventEmitter(), l = jest.spyOn(n, "on"), v = jest.spyOn(n, "off"), i = () => {
    expect(l).toHaveBeenCalledWith("mousemoveOnOverlay", expect.any(Function)), expect(l).toHaveBeenCalledWith("mousemoveOnBoundingComponent", expect.any(Function)), expect(l).toHaveBeenCalledWith("mouseleaveOnOverlay", expect.any(Function)), expect(l).toHaveBeenCalledWith("mouseleaveOnBoundingComponent", expect.any(Function));
  }, c = () => {
    expect(v).toHaveBeenCalledWith("mousemoveOnOverlay", expect.any(Function)), expect(v).toHaveBeenCalledWith("mousemoveOnBoundingComponent", expect.any(Function)), expect(v).toHaveBeenCalledWith("mouseleaveOnOverlay", expect.any(Function)), expect(v).toHaveBeenCalledWith("mouseleaveOnBoundingComponent", expect.any(Function));
  };
  beforeEach(() => {
    m = {
      current: document.createElement("div")
    }, O.mockReturnValue({
      overlayManagerEventEmitter: n,
      boundingComponentRef: m
    }), e = new p({
      onStart: jest.fn(),
      onStop: jest.fn(),
      timeoutDuration: 1e3
    }), u = jest.fn(), r = jest.fn(), jest.spyOn(e, "requestStart").mockImplementation(u), jest.spyOn(e, "requestStop").mockImplementation(r);
  }), afterEach(() => {
    jest.clearAllMocks();
  }), it("adds events when mounted", () => {
    o(() => a({ timedEventManager: e })), i();
  }), it("removes events when unmounted", () => {
    const { unmount: t } = o(() => a({ timedEventManager: e }));
    t(), c();
  }), it.each([
    {
      eventName: "mousemoveOnOverlay",
      requestStartOnMouseMove: !0
    },
    {
      eventName: "mousemoveOnBoundingComponent",
      requestStartOnMouseMove: !0
    },
    {
      eventName: "mousemoveOnOverlay",
      requestStartOnMouseMove: !1
    },
    {
      eventName: "mousemoveOnBoundingComponent",
      requestStartOnMouseMove: !1
    }
  ])("calls requestStart when $eventName is emitted and requestStartOnMouseMove is $requestStartOnMouseMove", ({ eventName: t, requestStartOnMouseMove: s }) => {
    o(() => a({ timedEventManager: e, requestStartOnMouseMove: s })), n.emit(t), expect(u).toHaveBeenCalledTimes(s ? 1 : 0);
  }), it.each([
    {
      eventName: "mouseleaveOnBoundingComponent",
      requestStopOnMouseMove: !0
    },
    {
      eventName: "mouseleaveOnOverlay",
      requestStopOnMouseMove: !1
    },
    {
      eventName: "mouseleaveOnBoundingComponent",
      requestStopOnMouseMove: !1
    }
  ])("calls requestStop when $eventName is emitted and requestStopOnMouseMove is $requestStopOnMouseMove", ({ eventName: t, requestStopOnMouseMove: s }) => {
    o(() => a({ timedEventManager: e, requestStopOnMouseMove: s })), n.emit(t), expect(r).toHaveBeenCalledTimes(s ? 1 : 0);
  }), it("calls requestStop when mouseleaveOnOverlay is emitted and the relatedTarget is not the boundingComponent or a descendant of it", () => {
    o(() => a({ timedEventManager: e }));
    const t = new MouseEvent("mouseleaveOnOverlay", {
      relatedTarget: document.createElement("div")
    });
    n.emit("mouseleaveOnOverlay", t), expect(r).toHaveBeenCalled();
  }), it("does not call requestStop when mouseleaveOnOverlay is emitted but the relatedTarget is the boundingComponent", () => {
    o(() => a({ timedEventManager: e }));
    const t = new MouseEvent("mouseleaveOnOverlay", {
      relatedTarget: m.current
    });
    n.emit("mouseleaveOnOverlay", t), expect(r).not.toHaveBeenCalled();
  }), it("does not call requestStop when mouseleaveOnOverlay is emitted but the relatedTarget is a descendant of the boundingComponent", () => {
    o(() => a({ timedEventManager: e }));
    const s = m.current.appendChild(document.createElement("div")).appendChild(document.createElement("div")), d = new MouseEvent("mouseleaveOnOverlay", {
      relatedTarget: s
    });
    n.emit("mouseleaveOnOverlay", d), expect(r).not.toHaveBeenCalled();
  }), it("does not register events when timedEventManager is null", () => {
    o(() => a({ timedEventManager: null })), expect(l).not.toHaveBeenCalled();
  });
});
