import { r as a, w as i } from "../../../react.esm-GKFzux-6.mjs";
import o from "../useResizeObserver.js";
jest.mock("use-debounce", () => ({
  useDebouncedCallback: jest.fn((t) => t)
}));
describe("useResizeObserver", () => {
  let t, s;
  beforeEach(() => {
    t = jest.fn(), s = jest.fn(), global.ResizeObserver = jest.fn().mockImplementation(() => ({
      observe: t,
      disconnect: s
    }));
  }), afterEach(() => {
    jest.clearAllMocks();
  });
  const c = (e) => {
    expect(t).toHaveBeenCalledWith(e.current);
  }, l = () => {
    expect(s).toHaveBeenCalled();
  };
  it("observes the target element", () => {
    const e = { current: {} };
    a(() => o(e, { handleResize: jest.fn() })), c(e);
  }), it("disconnects the observer when unmounted", () => {
    const e = { current: {} }, { unmount: n } = a(() => o(e, { handleResize: jest.fn() }));
    n(), l();
  }), it("does not update the observer when dependecies does not change", async () => {
    const e = { current: {} }, n = () => {
    }, { rerender: r } = a(() => o(e, { handleResize: n }));
    t.mockClear(), r(), await i(() => {
      expect(t).not.toHaveBeenCalled(), expect(s).not.toHaveBeenCalled();
    });
  }), it("updates the observer when targetElement or handleResize changes", async () => {
    const e = { current: {} }, n = jest.fn(), { rerender: r } = a(({ targetElement: m, handleResize: u }) => o(m, { handleResize: u }), {
      initialProps: { targetElement: e, handleResize: n }
    });
    jest.clearAllMocks();
    const d = jest.fn();
    r({ targetElement: e, handleResize: d }), await i(() => {
      c(e), l();
    }), jest.clearAllMocks();
    const h = { current: {} };
    r({ targetElement: h, handleResize: d }), await i(() => {
      c(h), l();
    });
  });
});
