import { r as t, w as d } from "../../../react.esm-GKFzux-6.mjs";
import l from "../useScrollOnDocument.js";
jest.mock("use-debounce", () => ({
  useDebouncedCallback: jest.fn((e) => e)
}));
describe("useScrollOnDocument", () => {
  const e = jest.fn();
  let o, c;
  const s = (n) => {
    expect(o).toHaveBeenCalledWith("scroll", n);
  }, r = (n) => {
    expect(c).toHaveBeenCalledWith("scroll", n);
  };
  beforeEach(() => {
    o = jest.spyOn(document, "addEventListener"), c = jest.spyOn(document, "removeEventListener");
  }), afterEach(() => {
    jest.clearAllMocks();
  }), it("adds a debounced scroll event listener", () => {
    t(() => l({ handleScroll: e })), s(e);
  }), it("removes the scroll event listener when unmounted", () => {
    const { unmount: n } = t(() => l({ handleScroll: e }));
    n(), r(e);
  }), it("dees not update the scroll event listener when handleScroll does not change", async () => {
    const { rerender: n } = t(() => l({ handleScroll: e }));
    o.mockClear(), n(), await d(() => {
      expect(o).not.toHaveBeenCalled(), expect(c).not.toHaveBeenCalled();
    });
  }), it("updates the scroll event listener when handleScroll changes", async () => {
    const { rerender: n } = t(({ handleScroll: i }) => l({ handleScroll: i }), {
      initialProps: { handleScroll: e }
    }), a = jest.fn();
    n({ handleScroll: a }), await d(() => {
      r(e), s(a);
    });
  }), it("calls handleScroll on scroll on document", () => {
    t(() => l({ handleScroll: e })), document.dispatchEvent(new Event("scroll")), expect(e).toHaveBeenCalled();
  });
});
